' GAMMA.BAS, Programm zur Gamma-Spektroskopie, Versuch P2-83  (J. 8/92)
'            nderung: Spannung bzw. Energie Null bei Kanal -2    (9/92)
'            nderung: Besser formatiert         (Peter Schlaile) (7/99)
'                      Umgerechnete Messwerte speicherbar

DEFINT I-J, L, X-Y: DEFLNG K, M
DIM k(255, 2), km(255, 2), kw(255, 2), kn(255), l(100), eth(14), ic(2)

DATA 32., 184.3, 477.3, 661.6, 209.8, 214.4, 962.9, 1118.1, 1172.7, 1332.5
DATA 59.6, 122., 511., 1273.6

FOR i = 1 TO 14
        READ eth(i)
NEXT i

OPEN "nulleffe.spe" FOR INPUT AS #1
        INPUT #1, tnull, t$
        FOR i = 0 TO 255
                INPUT #1, j, kn(i)
        NEXT i
CLOSE #1

ic(1) = 11#
leer$ = ">>" + STRING$(77, 32): chst$ = "Marke zu charakteristischen Pktn. "
chst$ = chst$ + "fhren, jeweils Taste Ins, zum Schlu PgDn": ic(2) = 14#
u$ = "######": reslt$ = "  =#######  Tges=#####s  Ttot=####s  Teff=#####s"
reslt$ = reslt$ + "  Zeff=#####/s          "
iso$(1) = "Co-060 ": iso$(2) = "Cs-137"

anfang: SCREEN 9: VIEW (119, 48)-(633, 300): WINDOW (-1, -1)-(256, 251)
LOCATE 23, 16: PRINT "0"; : LOCATE 23, 78: PRINT "255"; : LOCATE 23, 42
PRINT "Kanalnummer"; : LOCATE 4, 1: PRINT "Inhalt"
LINE (-1, -1)-(256, 251), 10, B

FOR iso = 1 TO 2
        COLOR ic(iso): LOCATE iso, 1: PRINT iso$(iso); : COLOR 15
        IF iso = 1 THEN PRINT STRING$(61, 32); "[J. 9/92]" ELSE PRINT
        LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4
        PRINT iso$(iso); "  einsetzen;   Messung (a)nfangen";
waita:
        GOSUB warten: IF k$ <> "a" AND k$ <> "A" GOTO waita

        LOCATE 25, 11: PRINT ";  Messung (n)ochmal anfangen,  (b)eenden";

neu:
        m = 1&: kmx = 250&: LOCATE 4, 9: PRINT USING u$; kmx
        CLS 1: LINE (-1, -1)-(256, 251), 10, B
        IF iso = 1 THEN LINE (230, 10)-(230, 150), 12

        FOR i = 0 TO 255
                k(i, iso) = 0&
        NEXT i

        OUT &H103, &H9A: OUT &H102, &H6: OUT &H102, &H0: OUT &H102, &H4
        dt = 0!: tanf = TIMER

trig:
        IF (INP(&H100) AND 2) <> 0 GOTO trig
        j = INP(&H104): k(j, iso) = k(j, iso) + 1&: IF j = 0 OR j = 255 GOTO nopset
        IF k(j, iso) < kmx GOTO weiter
        m = 2& * m: kmx = m * 250&
        LOCATE 4, 9: PRINT USING u$; kmx: CLS 1: LINE (-1, -1)-(256, 251), 10, B
        FOR i = 1 TO 254
                LINE (i, 0)-(i, k(i, iso) / m), 15
        NEXT i
        dt = dt + .45
nopset:
        OUT &H102, &H6: k$ = INKEY$: IF k$ = "" GOTO nxt
        IF k$ = "n" OR k$ = "N" GOTO neu
        IF k$ = "b" OR k$ = "B" GOTO endit ELSE GOTO nxt
weiter: OUT &H102, &H6: PSET (j, k(j, iso) / m)
nxt: OUT &H102, &H0: OUT &H102, &H4: GOTO trig

endit: tend = TIMER: IF tend < tanf THEN tend = tend + 86400!
        z = tend - tanf: ks = 0&
        FOR i = 1 TO 254
                ks = ks + k(i, iso)
        NEXT i
        dt = CSNG(ks) * .0006 + CSNG(k(0, iso) + k(255, iso)) * .00026 + dt
        teff = z - dt: fac = teff / tnull
       
        'IF INSTR(COMMAND$, "D") = 0 GOTO prtres

        f$ = "G" + CHR$(iso + 48) + LEFT$(COMMAND$ + "------", 6) + ".SPE"
        OPEN f$ FOR OUTPUT AS #1
                PRINT #1, teff; f$
                FOR i = 0 TO 255
                        PRINT #1, i; k(i, iso)
                NEXT i
        CLOSE #1
prtres:
        LOCATE iso, 7: COLOR ic(iso)
        PRINT USING reslt$; ks; z; dt; teff; CSNG(ks) / teff: COLOR 15
        LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4
        PRINT "Beliebige Taste:  Nulleff.-korr., gegltt. Spektrum mit Fehlergrenzen";
        GOSUB warten: GOSUB endpgm: CLS 1: LINE (-1, -1)-(256, 251), 10, B

        FOR i = 0 TO 255:  'Nulleffekt-Korrektur
                korr = CLNG(fac * CSNG(kn(i)))
                k(i, iso) = k(i, iso) - korr: PSET (i, korr / m), ic(iso)
                IF k(i, iso) < 0 THEN k(i, iso) = 0
        NEXT i

        FOR i = 2 TO 253  'Glttung (Geglttete Werte in k; km und kw fr Graphik)
                km(i, iso) = (k(i - 1, iso) + 2 * k(i, iso) + k(i + 1, iso) + 2) / 4
        NEXT i
        km(1, iso) = k(1, iso): km(254, iso) = k(254, iso)
        FOR i = 1 TO 254
                k(i, iso) = km(i, iso): km(i, iso) = k(i, iso) / m
                kw(i, iso) = SQR(k(i, iso)) / m:
        NEXT i

        FOR i = 1 TO 254  'Graphische Darstellung
                LINE (i, km(i, iso) - kw(i, iso))-(i, km(i, iso) + kw(i, iso)), ic(iso)
                CIRCLE (i, km(i, iso)), .3, ic(iso)
        NEXT i
NEXT iso

LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4
PRINT "Beliebige Taste:  Beide korrigierten Spektren gleichzeitig";
GOSUB warten: GOSUB endpgm: LOCATE 4, 1: PRINT STRING$(14, 32)

wiederh:
CLS 1: LINE (-1, -1)-(256, 251), 10, B
FOR i = 7 TO 22
        LOCATE i, 1: PRINT STRING$(14, 32);
NEXT i
FOR iso = 1 TO 2
        FOR i = 1 TO 254
                CIRCLE (i, km(i, iso)), .3, ic(iso)
        NEXT i
NEXT iso
LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4

PRINT "(f)ehlerbalken hinzufgen;  weiter mit anderer Taste";
GOSUB warten: GOSUB endpgm: IF k$ <> "f" AND k$ <> "F" GOTO eichen
FOR iso = 1 TO 2: FOR i = 1 TO 254
LINE (i, km(i, iso) - kw(i, iso))-(i, km(i, iso) + kw(i, iso)), ic(iso)
CIRCLE (i, km(i, iso)), .3, ic(iso): NEXT i: NEXT iso
eichen: eich = 0!: linie = 7: LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4

PRINT "Marke mit Pfeiltasten zum Cs-Photopeak fhren, dann Taste Ins";
IF INSTR(COMMAND$, "T") <> 0 THEN LINE (113, 249)-(113, 250), 10
x = 135: y = 45
marken: x = x + 1: GOSUB strich0
action: GOSUB warten: IF LEN(k$) = 1 GOTO action ELSE k$ = RIGHT$(k$, 1)
SELECT CASE k$
CASE "K": IF x < 3 GOTO action ELSE x = x - 1
CASE "M": IF x > 252 GOTO action ELSE x = x + 1
CASE "H": IF y > 225 GOTO action ELSE y = y + 20
CASE "P": IF y < 45 GOTO action ELSE y = y - 20
CASE "R": IF eich = 0! GOTO csmarke
LOCATE linie, 7: COLOR 13: PRINT USING "####keV"; (x + 2) * eich: COLOR 15
linie = linie + 1: LINE (x, y)-(x, y - 20), 13
IF linie < 20 GOTO marken ELSE GOTO ende
csmarke: eich = 661.6 / (x + 2): LOCATE linie, 8: COLOR 14: PRINT "662keV"
COLOR 15: linie = linie + 1: LINE (x, y)-(x, y - 20), ic(2)
IF INSTR(COMMAND$, "T") <> 0 THEN GOSUB th
LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4: PRINT chst$; : GOTO marken
CASE "Q": GOTO ende
CASE ELSE: GOTO action
END SELECT
LOCATE linie, 1: PRINT USING "K###"; x: GOSUB strich: GOTO action
ende: PUT (xo, yo - 20), l, PSET: COLOR 15
hwe: LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4
PRINT "(h)ardcopy;(s)peichern;(w)iederh. Auswertung;Progr.(a)nfang;  Progr.(e)nde";
GOSUB warten: GOSUB endpgm: SELECT CASE k$
CASE "w", "W": LOCATE 23, 17: PRINT STRING$(60, 32);
LOCATE 24, 17: PRINT STRING$(60, 32); : GOTO wiederh
CASE "a", "A": SCREEN 0: GOTO anfang
CASE "h", "H": LOCATE 25, 1: PRINT leer$; : LOCATE 25, 4
PRINT LEFT$(COMMAND$ + "------", 6); : GOSUB hardcopy: GOTO hwe
CASE "e", "E": SCREEN 0: CLOSE : END
CASE "s", "S": GOSUB speichern: GOTO hwe
CASE ELSE: GOTO hwe: END SELECT

warten: 'Warten auf Tastendruck
k$ = INKEY$: IF k$ = "" GOTO warten ELSE RETURN

strich: 'Strichmarke auf den Schirm setzen, alte Marke lschen
PUT (xo, yo - 20), l, PSET
strich0: xo = x: yo = y: GET (x, y)-(x, y - 20), l
LINE (x, y)-(x, y - 20), 15: RETURN

hardcopy: 'Hardcopy-Routine auf Interrupt 7E anspringen
GOSUB pt: k$ = CHR$(205) + CHR$(&H7E) + CHR$(203): n% = VARPTR(k$)
n% = PEEK(n% + 2) + 256 * PEEK(n% + 3): 'CALL ABSOLUTE(n%)
'Zwischenzeitliche Tastenanschlge unwirksam machen:
DEF SEG = 0: POKE &H41C, PEEK(&H41A): POKE &H41D, PEEK(&H41B)
DEF SEG : RETURN

pt: DEF SEG = 0 'Printer-Test
tloop: adr% = PEEK(&H408) + 1 + 256 * PEEK(&H409): x = INP(adr%)
delsec = .15: GOSUB delay: IF (x AND 8) = 0 THEN GOTO prtdru
GOSUB delay: x = INP(adr%): IF (x AND 8) = 8 THEN DEF SEG : RETURN
prtdru: z = CSRLIN: y = POS(y): LOCATE 25, 4: PRINT "DRUCKER!";
GOSUB delay: LOCATE 25, 4: PRINT "        "; : LOCATE z, y: GOTO tloop

delay: 'Verzgerung um DELSEC Sekunden
timend = TIMER + delsec
asktim: IF TIMER > timend THEN RETURN ELSE GOTO asktim

th: 'mit Cs-Php korresp. char. Lagen
j = 14: FOR i = 1 TO 14: IF i = 5 THEN j = 9 ELSE IF i = 11 THEN j = 10
ii = CINT(eth(i) / eich) - 2: LINE (ii, -1)-(ii, 5), j: NEXT i
LOCATE 23, 17: COLOR 7
PRINT "R Co57            Ck-----Cs137                Ck------Co60";
LOCATE 24, 17:
PRINT "Am241 3R           Na22                Ck------Co60 Na22";
COLOR 15: RETURN

endpgm: 'Mit End Programmabbruch
IF k$ = CHR$(0) + "O" THEN SCREEN 0: CLOSE : END ELSE RETURN

speichern:
OPEN "MESSCO60.SP2" FOR OUTPUT AS #1
FOR i = 0 TO 254
    PRINT #1, km(i, 0)
NEXT
CLOSE #1

OPEN "MESCS137.SP2" FOR OUTPUT AS #1
FOR i = 0 TO 254
    PRINT #1, km(i, 1)
NEXT
CLOSE #1
RETURN

