#!/usr/bin/tclsh

array set werte [exec cat [lindex $argv 0]]

set xm 0.0
set N 0.0

foreach i [array names werte] {
    set xm [expr $xm+$i*$werte($i)]
    set N [expr $N+$werte($i)]
}
set xm [expr $xm/$N]

puts "N: $N"
puts "Mittelwert: $xm"

set s 0.0
foreach i [array names werte] {
    set s [expr $s+$werte($i)*pow($xm-$i,2)]
}

set s [expr sqrt($s/($N-1))]

puts "Standardabweichung der Einzelmesswerte: $s"
puts "Standardabweichung des Mittelwertes: [expr $s/sqrt($N)]"

