#!/usr/bin/tclsh

array set b [exec cat [lindex $argv 0]]
array set e [exec cat [lindex $argv 1]]

set xmin [lindex $argv 2]
set xmax [lindex $argv 3]

set chi 0.0
for {set x $xmin} {$x <= $xmax} {incr x} {
    catch {
	puts "$x & $b($x) & $e($x) \\\\"
	set chi [expr $chi+pow($b($x)-$e($x),2)/$e($x)]
    }
}
puts "Der Chi-Quadrattest ergab: \$chi^2 = $chi\$"
