#!/bin/tclsh

set xm [lindex $argv 0]
set x1 [lindex $argv 1]
set x2 [lindex $argv 2]
set scale [lindex $argv 3]

set xfac 1.0
for {set i 2} {$i < $x1} {incr i} {
    set xfac [expr $xfac*$i]
}
if {$x1 == 0} {
    puts "0 [expr exp(-$xm)*$scale]"
    incr x1
}
for {set x $x1} {$x <= $x2} {incr x} {
    set xfac [expr $xfac*$x]
    puts "$x [expr pow($xm, $x) / $xfac * exp(-$xm)*$scale]"
}
